diff --git a/web/pgadmin/misc/cloud/static/js/CloudWizard.jsx b/web/pgadmin/misc/cloud/static/js/CloudWizard.jsx
new file mode 100644
index 000000000..f27c43323
--- /dev/null
+++ b/web/pgadmin/misc/cloud/static/js/CloudWizard.jsx
@@ -0,0 +1,454 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+
+import gettext from 'sources/gettext';
+import url_for from 'sources/url_for';
+import React from 'react';
+import { Box, Table, TableBody, TableCell, TableHead, TableRow, Paper } from '@material-ui/core';
+import { makeStyles } from '@material-ui/core/styles';
+import Wizard from '../../../../static/js/helpers/wizard/Wizard';
+import WizardStep from '../../../../static/js/helpers/wizard/WizardStep';
+import {FormFooterMessage, MESSAGE_TYPE, InputToggle } from '../../../../static/js/components/FormComponents';
+import getApiInstance from '../../../../static/js/api_instance';
+import SchemaView from '../../../../static/js/SchemaView';
+import Alertify from 'pgadmin.alertifyjs';
+import PropTypes from 'prop-types';
+import {CloudInstanceDetailsSchema, CloudDBCredSchema, DatabaseSchema} from './cloud_db_details_schema.ui';
+import { isEmptyString } from 'sources/validators';
+import pgAdmin from 'sources/pgadmin';
+import { getNodeAjaxOptions, getNodeListById } from 'pgbrowser/node_ajax';
+import { commonTableStyles } from '../../../../static/js/Theme';
+import clsx from 'clsx';
+
+const useStyles = makeStyles(() =>
+  ({
+    messageBox: {
+      marginBottom: '1em',
+      display: 'flex',
+    },
+    messagePadding: {
+      flex: 2.5
+    },
+    toggleButton: {
+      height: '100px',
+    },
+    table: {
+      marginLeft: '4px',
+      marginTop: '12px',
+    },
+    tableCellHeading: {
+      fontWeight: 'bold',
+      paddingLeft: '9px',
+    },
+    tableCell: {
+      padding: '9px',
+      paddingLeft: '11px',
+    }
+  }),
+);
+
+export default function CloudWizard({ nodeInfo, nodeData }) {
+  const classes = useStyles();
+  const tableClasses = commonTableStyles();
+
+  var steps = ['Cloud Provider', 'Credentials', 'Instance Specification', 'Database Details', 'Review'];
+  const [currentStep, setCurrentStep] = React.useState('');
+  const [selectionVal, setCloudSelection] = React.useState('');
+  const [errMsg, setErrMsg] = React.useState('');
+  const [cloudInstanceDetailsInstance, setCloudInstanceDetailsInstance] = React.useState();
+  const [cloudDBCredInstance, setCloudDBCredInstance] = React.useState();
+  const [cloudDBInstance, setCloudDBInstance] = React.useState();
+  const [cloudInstanceDetails, setCloudInstanceDetails] = React.useState({});
+  const [cloudDBCred, setCloudDBCred] = React.useState({});
+  const [cloudDBDetails, setCloudDBDetails] = React.useState({});
+  const [callRDSAPI, setCallRDSAPI] = React.useState({});
+  const axiosApi = getApiInstance();
+
+  React.useEffect(() => {
+    if (callRDSAPI == 2) {
+      const cloudDBInstanceSchema = new CloudInstanceDetailsSchema({
+        version: ()=>getNodeAjaxOptions('get_aws_db_versions', pgAdmin.Browser.Nodes['server'], nodeInfo, nodeData, {
+          useCache:false,
+          cacheNode: 'server',
+          customGenerateUrl: ()=>{
+            return url_for('cloud.get_aws_db_versions');
+          }
+        }),
+        getInstances: (engine, reload, options) =>
+        {
+          return new Promise((resolve, reject)=>{
+            const api = getApiInstance();
+            var _url = url_for('cloud.get_aws_db_instances') ;
+
+            if (engine) _url += '?eng_version=' + engine;
+            if (reload) {
+              api.get(_url)
+                .then(res=>{
+                  let data = res.data.data;
+                  resolve(data);
+                })
+                .catch((err)=>{
+                  reject(err);
+                });
+            } else {
+              resolve(options);
+            }
+          });
+        },
+        instance_type: ()=>getNodeAjaxOptions('get_aws_db_instances', pgAdmin.Browser.Nodes['server'], nodeInfo, nodeData, {
+          useCache:false,
+          cacheNode: 'server',
+          customGenerateUrl: ()=>{
+            return url_for('cloud.get_aws_db_instances');
+          }
+        }),
+        server_groups: ()=>getNodeListById(pgAdmin.Browser.Nodes['server_group'], nodeInfo, nodeData),
+      }, {
+        gid: nodeInfo['server_group']._id,
+      });
+      setCloudInstanceDetailsInstance(cloudDBInstanceSchema);
+    }
+  }, [callRDSAPI]);
+
+  React.useEffect(() => {
+    const cloudDBCredSchema = new CloudDBCredSchema({
+      regions: ()=>getNodeAjaxOptions('get_aws_regions', pgAdmin.Browser.Nodes['server'], nodeInfo, nodeData, {
+        useCache:false,
+        cacheNode: 'server',
+        customGenerateUrl: ()=>{
+          return url_for('cloud.get_aws_regions');
+        }
+      }),
+    });
+    setCloudDBCredInstance(cloudDBCredSchema);
+
+    const cloudDBSchema = new DatabaseSchema({
+      server_groups: ()=>getNodeListById(pgAdmin.Browser.Nodes['server_group'], nodeInfo, nodeData),
+    },
+    {
+      gid: nodeInfo['server_group']._id,
+    }
+    );
+    setCloudDBInstance(cloudDBSchema);
+
+  }, []);
+
+  const wizardStepChange = (data) => {
+    setCurrentStep(data.currentStep);
+  };
+
+  const validateCloudStep1 = (cloudDBCred) => {
+    let isError = false;
+    if (isEmptyString(cloudDBCred.aws_access_key) || isEmptyString(cloudDBCred.aws_secret_access_key)) {
+      isError = true;
+    }
+    return isError;
+  };
+
+  const validateCloudStep2 = (cloudInstanceDetails) => {
+    let isError = false;
+    if (isEmptyString(cloudInstanceDetails.aws_name) ||
+    isEmptyString(cloudInstanceDetails.aws_db_version) || isEmptyString(cloudInstanceDetails.aws_instance_type) ||
+    isEmptyString(cloudInstanceDetails.aws_storage_type)|| isEmptyString(cloudInstanceDetails.aws_storage_size)) {
+      isError = true;
+    }
+
+    if(cloudInstanceDetails.aws_storage_type == 'io1' && isEmptyString(cloudInstanceDetails.aws_storage_IOPS)) {
+      isError = true;
+    }
+    if (isEmptyString(cloudInstanceDetails.aws_public_ip)) cloudInstanceDetails.aws_public_ip = '127.0.0.1/32';
+    return isError;
+  };
+
+  const validateCloudStep3 = (cloudDBDetails) => {
+    let isError = false;
+    if (isEmptyString(cloudDBDetails.aws_db_name) ||
+    isEmptyString(cloudDBDetails.aws_db_username) || isEmptyString(cloudDBDetails.aws_db_password)) {
+      isError = true;
+    }
+    if (isEmptyString(cloudDBDetails.aws_db_port)) cloudDBDetails.aws_db_port = 5432;
+    if (isEmptyString(cloudDBDetails.gid)) cloudDBDetails.gid = nodeInfo['server_group']._id;
+    return isError;
+  };
+
+  const getStorageType = (cloudInstanceDetails) => {
+    let _storage_type = 'General Purpose SSD (gp2)',
+      _io1 = undefined;
+
+    if(cloudInstanceDetails.aws_storage_type == 'gp2') _storage_type = 'General Purpose SSD (gp2)';
+    else if(cloudInstanceDetails.aws_storage_type == 'io1') {
+      _storage_type = 'Provisioned IOPS SSD (io1)';
+      _io1 = cloudInstanceDetails.aws_storage_IOPS;
+    }
+    else if(cloudInstanceDetails.aws_storage_type == 'magnetic') _storage_type = 'Magnetic';
+
+    return [_io1, _storage_type];
+  };
+
+  const onSave = () => {
+    var _url = url_for('cloud.deploy_on_cloud');
+    const post_data = {
+      gid: nodeInfo.server_group._id,
+      cloud: selectionVal,
+      secret: cloudDBCred,
+      instance_details:cloudInstanceDetails,
+      db_details: cloudDBDetails
+    };
+    axiosApi.post(_url, post_data)
+      .then((res) => {
+        pgAdmin.Browser.Events.trigger('pgadmin:browser:tree:add', res.data.data.node, {'server_group': nodeInfo['server_group']});
+        pgAdmin.Browser.Events.trigger('pgadmin-bgprocess:created', Alertify.cloudWizardDialog());
+        Alertify.cloudWizardDialog().close();
+      })
+      .catch((error) => {
+        Alertify.error(gettext(`Error while saving cloud wizard data: ${error.response.data.errormsg}`));
+      });
+  };
+
+  const disableNextCheck = () => {
+    setCallRDSAPI(currentStep);
+    let isError = false;
+    switch (currentStep) {
+    case 0:
+      setCloudSelection('rds');
+      break;
+    case 1:
+      isError = validateCloudStep1(cloudDBCred);
+      break;
+    case 2:
+      isError = validateCloudStep2(cloudInstanceDetails);
+      break;
+    case 3:
+      isError = validateCloudStep3(cloudDBDetails);
+      break;
+    default:
+      break;
+    }
+    return isError;
+  };
+
+  const onBeforeNext = (activeStep) => {
+    return new Promise((resolve, reject)=>{
+      if(activeStep == 1) {
+        setErrMsg([MESSAGE_TYPE.INFO, 'Validating credentials...']);
+        var _url = url_for('cloud.verify_credentials');
+        const post_data = {
+          cloud: selectionVal,
+          secret: cloudDBCred,
+        };
+        axiosApi.post(_url, post_data)
+          .then((res) => {
+            if(!res.data.success) {
+              setErrMsg([MESSAGE_TYPE.ERROR, res.data.info]);
+              reject();
+            } else {
+              setErrMsg(['', '']);
+              resolve();
+            }
+          })
+          .catch(() => {
+            setErrMsg([MESSAGE_TYPE.ERROR, 'Error while checking cloud credentials']);
+            reject();
+          });
+      } else {
+        resolve();
+      }
+    });
+  };
+
+  const onDialogHelp = () => {
+    window.open(url_for('help.static', { 'filename': 'cloud_deployment.html' }), 'pgadmin_help');
+  };
+
+  function createData(name, value) {
+    return { name, value };
+  }
+
+  let cloud = '';
+
+  switch (selectionVal) {
+  case 'rds':
+    cloud = 'Amazon RDS';
+    break;
+  case 'azure':
+    cloud = 'Azure PostgreSQL';
+    break;
+  case 'biganimal':
+    cloud = 'EDB Big Animal';
+    break;
+  }
+
+  const rows1 = [
+    createData('Cloud', cloud),
+    createData('Instance name', cloudInstanceDetails.aws_name),
+    createData('Public IP', cloudInstanceDetails.aws_public_ip),
+  ];
+
+  const rows2 = [
+    createData('PostgreSQL version', cloudInstanceDetails.aws_db_version),
+    createData('Instance type', cloudInstanceDetails.aws_instance_type),
+  ];
+
+  let _storage_type = getStorageType(cloudInstanceDetails);
+
+  const rows3 = [
+    createData('Storage type', _storage_type[1]),
+    createData('Allocated storage', cloudInstanceDetails.aws_storage_size + ' GiB'),
+  ];
+  if (_storage_type[0] !== undefined) {
+    rows3.push(createData('Provisioned IOPS', _storage_type[0]));
+  }
+
+  const rows4 = [
+    createData('Database name', cloudDBDetails.aws_db_name),
+    createData('Username', cloudDBDetails.aws_db_username),
+    createData('Password', 'xxxxxxx'),
+    createData('Port',  cloudDBDetails.aws_db_port),
+  ];
+
+  const onErrClose = React.useCallback(()=>{
+    setErrMsg([]);
+  });
+
+
+  const displayTableRows = (rows) => {
+    return rows.map((row) => (
+      <TableRow key={row.name} >
+        <TableCell scope="row">{row.name}</TableCell>
+        <TableCell align="right">{row.value}</TableCell>
+      </TableRow>
+    ));
+  };
+
+  return (
+    <>
+      <Wizard
+        title={gettext('Deploy Cloud Instance')}
+        stepList={steps}
+        disableNextStep={disableNextCheck}
+        onStepChange={wizardStepChange}
+        onSave={onSave}
+        onHelp={onDialogHelp}
+        beforeNext={onBeforeNext}>
+        <WizardStep stepId={0}>
+          <Box className={classes.messageBox}>
+            <Box className={classes.messagePadding}>{gettext('Deploy on Amazon RDS cloud.')}</Box>
+          </Box>
+          <Box className={classes.messageBox}>
+            <InputToggle
+              value='rds'
+              options={[{'label': gettext('Amazon RDS'), value: 'rds'}]}
+              className={classes.toggleButton}
+              onChange={(value) => {
+                setCloudSelection(value);}
+              }
+            >
+            </InputToggle>
+          </Box>
+          <Box className={classes.messageBox}>
+            <Box className={classes.messagePadding}>{gettext('More cloud providers are coming soon...')}</Box>
+          </Box>
+        </WizardStep>
+        <WizardStep stepId={1} >
+          {cloudDBCredInstance &&
+            <SchemaView
+              formType={'dialog'}
+              getInitData={() => { /*This is intentional (SonarQube)*/ }}
+              viewHelperProps={{ mode: 'create' }}
+              schema={cloudDBCredInstance}
+              showFooter={false}
+              isTabView={false}
+              onDataChange={(isChanged, changedData) => {
+                setCloudDBCred(changedData);
+              }}
+            />
+          }
+          <FormFooterMessage type={errMsg[0]} message={errMsg[1]} onClose={onErrClose} />
+        </WizardStep>
+        <WizardStep stepId={2} >
+          {cloudInstanceDetailsInstance &&
+            <SchemaView
+              formType={'dialog'}
+              getInitData={() => { /*This is intentional (SonarQube)*/ }}
+              viewHelperProps={{ mode: 'create' }}
+              schema={cloudInstanceDetailsInstance}
+              showFooter={false}
+              isTabView={false}
+              onDataChange={(isChanged, changedData) => {
+                setCloudInstanceDetails(changedData);
+              }}
+            />
+          }
+        </WizardStep>
+        <WizardStep stepId={3} >
+          {cloudDBInstance &&
+            <SchemaView
+              formType={'dialog'}
+              getInitData={() => { /*This is intentional (SonarQube)*/ }}
+              viewHelperProps={{ mode: 'create' }}
+              schema={cloudDBInstance}
+              showFooter={false}
+              isTabView={false}
+              onDataChange={(isChanged, changedData) => {
+                setCloudDBDetails(changedData);
+              }}
+            />
+          }
+        </WizardStep>
+        <WizardStep stepId={4} >
+          <Box className={classes.boxText}>{gettext('Please review the details before creating the cloud instance.')}</Box>
+          <Paper variant="outlined" elevation={0} className={classes.summaryContainer}>
+            <Table aria-label="simple table" className={clsx(tableClasses.table)}>
+              <TableBody>
+                {displayTableRows(rows1)}
+              </TableBody>
+            </Table>
+            <Table aria-label="simple table" className={clsx(tableClasses.table)}>
+              <TableHead>
+                <TableRow>
+                  <TableCell colSpan={2}>{gettext('Version and Instance Details')}</TableCell>
+                </TableRow>
+              </TableHead>
+              <TableBody>
+                {displayTableRows(rows2)}
+              </TableBody>
+            </Table>
+            <Table aria-label="simple table" className={clsx(tableClasses.table)}>
+              <TableHead>
+                <TableRow>
+                  <TableCell colSpan={2}>{gettext('Storage Details')}</TableCell>
+                </TableRow>
+              </TableHead>
+              <TableBody>
+                {displayTableRows(rows3)}
+              </TableBody>
+            </Table>
+            <Table aria-label="simple table" className={clsx(tableClasses.table)}>
+              <TableHead>
+                <TableRow>
+                  <TableCell colSpan={2}>{gettext('Database Details')}</TableCell>
+                </TableRow>
+              </TableHead>
+              <TableBody>
+                {displayTableRows(rows4)}
+              </TableBody>
+            </Table>
+          </Paper>
+        </WizardStep>
+      </Wizard>
+    </>
+  );
+}
+
+CloudWizard.propTypes = {
+  nodeInfo: PropTypes.object,
+  nodeData: PropTypes.object,
+};
+
+
diff --git a/web/pgadmin/misc/cloud/static/js/cloud.js b/web/pgadmin/misc/cloud/static/js/cloud.js
new file mode 100644
index 000000000..9519fd6b8
--- /dev/null
+++ b/web/pgadmin/misc/cloud/static/js/cloud.js
@@ -0,0 +1,151 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+import React from 'react';
+import ReactDOM from 'react-dom';
+import Theme from 'sources/Theme';
+import CloudWizard from './CloudWizard';
+
+
+// Cloud Wizard
+define('pgadmin.misc.cloud', [
+  'sources/gettext', 'sources/url_for', 'jquery', 'underscore',
+  'pgadmin.alertifyjs',
+  'pgadmin.browser',
+  'pgadmin.browser.wizard',
+], function(
+  gettext, url_for, $, _, Alertify, pgBrowser
+) {
+
+  // if module is already initialized, refer to that.
+  if (pgBrowser.Cloud) {
+    return pgBrowser.Cloud;
+  }
+
+  // Create an Object Cloud of pgBrowser class
+  pgBrowser.Cloud = {
+    init: function() {
+      if (this.initialized)
+        return;
+
+      this.initialized = true;
+
+      // Define the nodes on which the menus to be appear
+      var menus = [{
+        name: 'register_and_deploy_cloud_instance',
+        module: this,
+        applies: ['object', 'context'],
+        callback: 'start_cloud_wizard',
+        priority: 15,
+        label: gettext('Deploy Cloud Instance...'),
+        icon: 'wcTabIcon icon-server',
+        enable: true,
+        data: {action: 'create'},
+        category: 'register',
+        node: 'server_group',
+      }, {
+        name: 'register_and_deploy_cloud_instance',
+        module: this,
+        applies: ['object', 'context'],
+        callback: 'start_cloud_wizard',
+        priority: 15,
+        label: gettext('Deploy Cloud Instance...'),
+        icon: 'wcTabIcon icon-server',
+        enable: true,
+        data: {action: 'create'},
+        category: 'register',
+        node: 'server',
+      }];
+
+      pgBrowser.add_menus(menus);
+      return this;
+    },
+
+    // Callback to draw Wizard Dialog
+    start_cloud_wizard: function() {
+
+      // Declare Wizard dialog
+      if (!Alertify.cloudWizardDialog) {
+        Alertify.dialog('cloudWizardDialog', function factory() {
+
+          // Generate wizard main container
+          var $container = $('<div class=\'wizard_dlg\' id=\'cloudWizardDlg\'></div>');
+          return {
+            main: function () {
+              /*This is intentional (SonarQube)*/
+            },
+            setup: function () {
+              return {
+                // Set options for dialog
+                options: {
+                  frameless: true,
+                  resizable: true,
+                  autoReset: false,
+                  maximizable: true,
+                  closable: true,
+                  closableByDimmer: false,
+                  modal: true,
+                  pinnable: false,
+                },
+              };
+            },
+            build: function () {
+              this.elements.content.appendChild($container.get(0));
+              Alertify.pgDialogBuild.apply(this);
+              var t = pgBrowser.tree,
+                i = t.selected(),
+                d = this.d = i ? t.itemData(i) : undefined,
+                info = this.info = pgBrowser.tree.getTreeNodeHierarchy(i);
+
+              setTimeout(function () {
+                if (document.getElementById('cloudWizardDlg')) {
+                  ReactDOM.render(
+                    <Theme>
+                      <CloudWizard nodeInfo={info} nodeData={d} />
+                    </Theme>,
+                    document.getElementById('cloudWizardDlg'));
+                  Alertify.cloudWizardDialog().elements.modal.style.maxHeight=0;
+                  Alertify.cloudWizardDialog().elements.modal.style.maxWidth='none';
+                  Alertify.cloudWizardDialog().elements.modal.style.overflow='visible';
+                  Alertify.cloudWizardDialog().elements.dimmer.style.display='none';
+                }
+              }, 500);
+
+            },
+            prepare: function () {
+              $container.empty().append('<div class=\'cloud_wizard_container\'></div>');
+            },
+            hooks: {
+              // Triggered when the dialog is closed
+              onclose: function () {
+                // Clear the view and remove the react component.
+                return setTimeout((function () {
+                  ReactDOM.unmountComponentAtNode(document.getElementById('cloudWizardDlg'));
+                  return Alertify.cloudWizardDialog().destroy();
+                }), 500);
+              },
+            }
+          };
+        });
+      }
+      // Call Grant Wizard Dialog and set dimensions for wizard
+      Alertify.cloudWizardDialog('').set({
+        onmaximize:function(){
+          Alertify.cloudWizardDialog().elements.modal.style.maxHeight='initial';
+        },
+        onrestore:function(){
+          Alertify.cloudWizardDialog().elements.modal.style.maxHeight=0;
+        },
+      }).resizeTo(920, 620);
+    },
+
+
+  };
+
+  return pgBrowser.Cloud;
+});
diff --git a/web/pgadmin/misc/cloud/static/js/cloud_db_details_schema.ui.js b/web/pgadmin/misc/cloud/static/js/cloud_db_details_schema.ui.js
new file mode 100644
index 000000000..08cd32437
--- /dev/null
+++ b/web/pgadmin/misc/cloud/static/js/cloud_db_details_schema.ui.js
@@ -0,0 +1,292 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+
+import gettext from 'sources/gettext';
+import BaseUISchema from 'sources/SchemaView/base_schema.ui';
+import { isEmptyString } from 'sources/validators';
+
+
+class CloudInstanceDetailsSchema extends BaseUISchema {
+  constructor(fieldOptions = {}, initValues = {}) {
+    super({
+      oid: undefined,
+      aws_name: '',
+      aws_public_ip: '127.0.0.1/32',
+      ...initValues
+    });
+
+    this.fieldOptions = {
+      ...fieldOptions,
+    };
+    this.initValues = initValues;
+  }
+
+  get idAttribute() {
+    return 'oid';
+  }
+
+  get baseFields() {
+    return [
+      {
+        id: 'aws_name', label: gettext('Instance name'), type: 'text',
+        mode: ['create'], noEmpty: true,
+      }, {
+        id: 'aws_public_ip', label: gettext('Public IP range'), type: 'text',
+        mode: ['create'],
+        helpMessage: gettext('IP Address range for permitting the inbound traffic. Ex: 127.0.0.1/32'),
+      }, {
+        type: 'nested-fieldset', label: gettext('Version & Instance'),
+        mode: ['create'],
+        schema: new InstanceSchema(this.fieldOptions.version,
+          this.fieldOptions.instance_type,
+          this.fieldOptions.getInstances),
+      }, {
+        type: 'nested-fieldset', label: gettext('Storage'),
+        mode: ['create'],
+        schema: new StorageSchema(),
+      },
+    ];
+  }
+}
+
+
+class CloudDBCredSchema extends BaseUISchema {
+  constructor(fieldOptions = {}, initValues = {}) {
+    super({
+      oid: null,
+      aws_region: '',
+      aws_access_key: '',
+      aws_secret_access_key: '',
+      aws_session_token: '',
+      is_valid_cred: false,
+      ...initValues
+    });
+
+    this.fieldOptions = {
+      ...fieldOptions,
+    };
+
+  }
+
+  get idAttribute() {
+    return 'oid';
+  }
+
+  get baseFields() {
+    return [
+      {
+        id: 'aws_region', label: gettext('Region'),
+        type: 'select',
+        options: this.fieldOptions.regions,
+        controlProps: { allowClear: false },
+        noEmpty: true,
+        helpMessage: gettext('The cloud instance will be deployed in the selected region.')
+      },{
+        id: 'aws_access_key', label: gettext('AWS access key'), type: 'text',
+        mode: ['create'], noEmpty: true,
+      }, {
+        id: 'aws_secret_access_key', label: gettext('AWS secret access key'), type: 'text',
+        mode: ['create'], noEmpty: true,
+      }, {
+        id: 'aws_session_token', label: gettext('AWS session token'), type: 'multiline',
+        mode: ['create'], noEmpty: false,
+        helpMessage: gettext('Temporary AWS session required session token.')
+      }
+    ];
+  }
+}
+
+
+class DatabaseSchema extends BaseUISchema {
+  constructor(fieldOptions = {}, initValues={}) {
+    super({
+      oid: undefined,
+      gid: undefined,
+      aws_db_name: '',
+      aws_db_username: '',
+      aws_db_password: '',
+      aws_db_confirm_password: '',
+      aws_db_port: 5432,
+      ...initValues,
+    });
+
+    this.fieldOptions = {
+      ...fieldOptions,
+    };
+
+  }
+
+  validate(data, setErrMsg) {
+    if(!isEmptyString(data.aws_db_password) && !isEmptyString(data.aws_db_confirm_password)
+    && data.aws_db_password != data.aws_db_confirm_password) {
+      setErrMsg('aws_db_confirm_password', gettext('Passwords do not match.'));
+      return true;
+    } else {
+      return false;
+    }
+  }
+
+  get idAttribute() {
+    return 'oid';
+  }
+
+  get baseFields() {
+    return [{
+      id: 'gid', label: gettext('Server group'), type: 'select',
+      options: this.fieldOptions.server_groups,
+      mode: ['create'],
+      controlProps: { allowClear: false },
+      noEmpty: true,
+    }, {
+      id: 'aws_db_name', label: gettext('Database name'), type: 'text',
+      mode: ['create'], noEmpty: true,
+    }, {
+      id: 'aws_db_username', label: gettext('Username'), type: 'text',
+      mode: ['create'], noEmpty: true,
+    }, {
+      id: 'aws_db_password', label: gettext('Password'), type: 'password',
+      mode: ['create'], noEmpty: true,
+    }, {
+      id: 'aws_db_confirm_password', label: gettext('Confirm password'),
+      type: 'password',
+      mode: ['create'], noEmpty: true,
+    }, {
+      id: 'aws_db_port', label: gettext('Port'), type: 'text',
+      mode: ['create'], noEmpty: true,
+    }];
+  }
+}
+
+export class InstanceSchema extends BaseUISchema {
+  constructor(versionOpts, instanceOpts, getInstances) {
+    super({
+      aws_db_version: '',
+      aws_db_instance_class: 'm',
+      aws_instance_type: '',
+      reload_instances: true,
+    });
+    this.versionOpts = versionOpts;
+    this.instanceOpts = instanceOpts;
+    this.getInstances = getInstances;
+    this.instanceData = [];
+  }
+
+  get baseFields() {
+    return [{
+      id: 'aws_db_version', label: gettext('Database version'),
+      type: 'select',
+      options: this.versionOpts,
+      controlProps: { allowClear: false },
+      deps: ['aws_name'],
+      noEmpty: true,
+    },{
+      id: 'aws_db_instance_class', label: gettext('Instance class'),
+      type: 'toggle',
+      options: [
+        {'label': gettext('Standard classes (includes m classes)'), value: 'm'},
+        {'label': gettext('Memory optimized classes (includes r & x classes)'), value: 'x'},
+        {'label': gettext('Burstable classes (includes t classes)'), value: 't'},
+      ],  noEmpty: true, orientation: 'vertical',
+    },{
+      id: 'aws_instance_type', label: gettext('Instance type'),
+      options: this.instanceOpts,  noEmpty: true,
+      controlProps: { allowClear: false },
+      deps: ['aws_db_version', 'aws_db_instance_class'],
+      depChange: (state, source)=> {
+        if (source[0] == 'aws_db_instance_class') {
+          state.reload_instances = false;
+        } else {
+          state.reload_instances = true;
+        }
+      },
+      type: (state) => {
+        return {
+          type: 'select',
+          options: ()=>this.getInstances(state.aws_db_version,
+            state.reload_instances, state.instanceData),
+          optionsLoaded: (options) => { state.instanceData = options; },
+          optionsReloadBasis: state.aws_db_version + (state.aws_db_instance_class || 'm'),
+          controlProps: {
+            allowClear: false,
+            filter: (options) => {
+              let pattern = 'db.m';
+              let pattern_1 = 'db.m';
+
+              if (state.aws_db_instance_class) {
+                pattern = 'db.' + state.aws_db_instance_class;
+                pattern_1 = 'db.' + state.aws_db_instance_class;
+              }
+              if (state.aws_db_instance_class == 'x') {
+                pattern_1 = 'db.' + 'r';
+              }
+              return options.filter((option) => {
+                return (option.value.includes(pattern) || option.value.includes(pattern_1));
+              });
+            },
+          }
+        };
+      },
+    }];
+  }
+}
+
+
+export class StorageSchema extends BaseUISchema {
+  constructor() {
+    super({
+      aws_storage_type: 'io1',
+      aws_storage_size: 100,
+      aws_storage_IOPS: 3000,
+      aws_storage_msg: 'Minimum: 20 GiB. Maximum: 16,384 GiB.'
+    });
+  }
+
+  get baseFields() {
+    return [
+      {
+        id: 'aws_storage_type', label: gettext('Storage type'), type: 'select',
+        mode: ['create'],
+        options: [
+          {'label': gettext('General Purpose SSD (gp2)'), 'value': 'gp2'},
+          {'label': gettext('Provisioned IOPS SSD (io1)'), 'value': 'io1'},
+          {'label': gettext('Magnetic'), 'value': 'standard'}
+        ], noEmpty: true,
+      },{
+        id: 'aws_storage_size', label: gettext('Allocated storage'), type: 'text',
+        mode: ['create'], noEmpty: true, deps: ['aws_storage_type'],
+        depChange: (state)=> {
+          if(state.aws_storage_type === 'io1') {
+            state.aws_storage_size = 100;
+          } else if(state.aws_storage_type === 'gp2') {
+            state.aws_storage_size = 20;
+          } else {
+            state.aws_storage_size = 5;
+          }
+        },
+        helpMessage: gettext('Size in GiB.')
+      }, {
+        id: 'aws_storage_IOPS', label: gettext('Provisioned IOPS'), type: 'text',
+        mode: ['create'],
+        visible: (state) => {
+          if(state.aws_storage_type === 'io1') {
+            state.aws_storage_IOPS = 3000;
+            return true;
+          }
+          return false;
+        } , deps: ['aws_storage_type']
+      },
+    ];
+  }
+}
+
+export {
+  CloudInstanceDetailsSchema,
+  CloudDBCredSchema,
+  DatabaseSchema,
+};
